commit f9912e0d61c0c0f225d8d910c4b506135cc408db
Author: freddy77 <freddy77>
Date:   Mon Jan 14 19:21:06 2008 +0000

    finish patch for HY008

diff --git a/ChangeLog b/ChangeLog
index 021efb9..f318306 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Jan 14 20:20:31 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/odbc.c:
+	- handle SQLCancel in signal handlers
+
 Sun Jan 13 20:59:55 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c src/odbc/unittests/cancel.c src/tds/token.c:
 	- detect cancellation and add proper error
@@ -55,4 +59,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2468 2008/01/13 20:01:43 freddy77 Exp $
+$Id: ChangeLog,v 1.2469 2008/01/14 19:21:06 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 59fdfc1..a58d547 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.103 2007/11/26 18:12:30 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.104 2008/01/14 19:21:06 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -370,6 +370,7 @@ struct _hstmt
 	int special_row;
 	/* do NOT free cursor, free from socket or attach to connection */
 	TDSCURSOR *cursor;
+	unsigned char cancel_sent;
 };
 
 typedef struct _henv TDS_ENV;
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index df2cc9a..74f8057 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.467 2008/01/13 20:01:44 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.468 2008/01/14 19:21:06 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -562,6 +562,7 @@ odbc_lock_statement(TDS_STMT* stmt)
 		tds->query_timeout = (stmt->attr.query_timeout != DEFAULT_QUERY_TIMEOUT) ?
 			stmt->attr.query_timeout : stmt->dbc->default_query_timeout;
 	stmt->dbc->current_statement = stmt;
+	stmt->cancel_sent = 0;
 	return 1;
 }
 
@@ -1582,6 +1583,7 @@ SQLCancel(SQLHSTMT hstmt)
 
 	/* FIXME test current statement */
 
+	stmt->cancel_sent = 1;
 	if (tds_send_cancel(tds) == TDS_FAIL) {
 		ODBC_SAFE_ERROR(stmt);
 		ODBC_RETURN(stmt, SQL_ERROR);
@@ -1592,7 +1594,9 @@ SQLCancel(SQLHSTMT hstmt)
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
 
-	stmt->dbc->current_statement = NULL;
+	/* only if we processed cancel reset statement */
+	if (stmt->dbc->current_statement && stmt->dbc->current_statement == stmt && tds->state == TDS_IDLE)
+		stmt->dbc->current_statement = NULL;
 
 	ODBC_RETURN_(stmt);
 }
@@ -2025,6 +2029,12 @@ odbc_errmsg_handler(const TDSCONTEXT * ctx, TDSSOCKET * tds, TDSMESSAGE * msg)
 		tdsdump_log(TDS_DBG_INFO1, "in timeout\n");
 		if (tds && (dbc = (TDS_DBC *) tds->parent) && dbc->current_statement) {
 			TDS_STMT *stmt = dbc->current_statement;
+			/* cancel sent, handling interrupt */
+			if (tds->in_cancel && stmt ->cancel_sent) {
+				stmt ->cancel_sent = 0;
+				tdsdump_log(TDS_DBG_INFO1, "returning from timeout\n");
+				return TDS_INT_TIMEOUT;
+			}
 			if (!tds->in_cancel)
 				odbc_errs_add(&stmt->errs, "HYT00", "Timeout expired");
 			stmt->errs.lastrc = SQL_ERROR;

